<?php

/**
 * Instagram callback - oauth
 */

define('QUIQQER_SYSTEM', true);
require dirname(dirname(dirname(dirname(dirname(__FILE__))))) . "/header.php";

if (!isset($_GET['code'])) {
    echo 'Something went wrong. oAuth token is missing.';
    exit;
}

try {
    $Connection = QUI\Instagram\Handler::getClient();

    $data     = $Connection->getOAuthToken($_GET['code']);
    $userData = $data->user;

    $result = QUI::getDataBase()->fetch(array(
        'from' => QUI\Instagram\Handler::getUserDatabaseTableName(),
        'where' => array(
            'oauth_uid' => $userData->username
        )
    ));

    if (!isset($result[0])) {
        QUI::getDataBase()->insert(
            QUI\Instagram\Handler::getUserDatabaseTableName(),
            array(
                'uid' => $User->getId(),
                'oauth_uid' => $userData->username,
                'oauth_provider' => 'instagram',
                'oauth_token' => $data->access_token,
                'oauth_secret' => '',
                'username' => $userData->username
            )
        );
    } else {
        QUI::getDataBase()->update(
            QUI\Instagram\Handler::getUserDatabaseTableName(),
            array(
                'uid' => $User->getId(),
                'oauth_provider' => 'instagram',
                'oauth_token' => $data->access_token,
                'oauth_secret' => '',
                'username' => $userData->username
            ),
            array(
                'oauth_uid' => $userData->id
            )
        );
    }

    header('Location: ' . URL_DIR);

} catch (\Exception $Exception) {
    QUI\System\Log::writeException($Exception);

    echo $Exception->getMessage();
    exit;
}
